## caffe 1.0.0

=== caffe/CMakeLists.txt ===
# generate protobuf sources
file(GLOB proto_files proto/*.proto)
caffe_protobuf_generate_cpp_py(${proto_gen_folder} proto_srcs proto_hdrs proto_python ${proto_files})

# include python files either to force generation
add_library(proto STATIC ${proto_hdrs} ${proto_srcs} ${proto_python})
caffe_default_properties(proto)
target_link_libraries(proto PUBLIC ${PROTOBUF_LIBRARIES})
target_include_directories(proto PUBLIC ${PROTOBUF_INCLUDE_DIR})

list(INSERT Caffe_LINKER_LIBS 0 PUBLIC proto) # note, crucial to prepend!

# --[ Caffe library

# creates 'test_srcs', 'srcs', 'test_cuda', 'cuda' lists
caffe_pickup_caffe_sources(${PROJECT_SOURCE_DIR})

if(HAVE_CUDA)
  caffe_cuda_compile(cuda_objs ${cuda})
  list(APPEND srcs ${cuda_objs} ${cuda})
endif()

add_library(caffe ${srcs})
caffe_default_properties(caffe)
target_link_libraries(caffe ${Caffe_LINKER_LIBS})
target_include_directories(caffe ${Caffe_INCLUDE_DIRS}
                                 PUBLIC
                                 $<BUILD_INTERFACE:${Caffe_INCLUDE_DIR}>
                                 $<INSTALL_INTERFACE:include>)
target_compile_definitions(caffe ${Caffe_DEFINITIONS})
if(Caffe_COMPILE_OPTIONS)
  target_compile_options(caffe ${Caffe_COMPILE_OPTIONS})
endif()
set_target_properties(caffe PROPERTIES
    VERSION   ${CAFFE_TARGET_VERSION}
    SOVERSION ${CAFFE_TARGET_SOVERSION}
    )

# ---[ Tests
 add_subdirectory(test)

# ---[ Install
install(DIRECTORY ${Caffe_INCLUDE_DIR}/caffe DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${proto_hdrs} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/caffe/proto)
install(TARGETS caffe proto EXPORT CaffeTargets DESTINATION ${CMAKE_INSTALL_LIBDIR})

file(WRITE ${PROJECT_BINARY_DIR}/__init__.py)
list(APPEND proto_python ${PROJECT_BINARY_DIR}/__init__.py)
install(PROGRAMS ${proto_python} DESTINATION python/caffe/proto)

=== debian/changelog ===
caffe (1.0.0-6) unstable; urgency=medium

  * Bump debhelper compat to 11.
  * Bump Standards-Version to 4.1.3 (no change).
  * Vcs-* fields point to Salsa.
  * Don't hardcode python3.5 in the patch.
  * Fix insecure-copyright-format-uri.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 27 Jan 2018 04:37:42 +0000

caffe (1.0.0-5) unstable; urgency=medium

  * Apply updates from upstream master branch.
    - Remove merged patch cmake-change-static-lib-name.patch.
  * Bump Standards-Version to 4.1.2 (no change).
  * Update description of caffe-doc.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 19 Dec 2017 02:35:35 +0000

caffe (1.0.0-4) unstable; urgency=medium

  * Update my name in control and copyright.
  * Bump Standards-Version to 4.1.1 . No change needed.
  * Use dh_missing --list-missing instead of dh_install --list-missing .
  * Remove the dirty hacks in the doc build.
  * Add several libjs* dependencies for the doc package.
  * Don't build binaries in indep-only build mode.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 18 Dec 2017 11:51:53 +0000

caffe (1.0.0-3) unstable; urgency=medium

  * Upload to unstable.
  * Set Multi-Arch of the dev package to same.
  * Bump Standards Version to 4.0.0 (No change needed).

 -- Zhou Mo <cdluminate@gmail.com>  Fri, 23 Jun 2017 01:39:36 +0000

caffe (1.0.0-2) experimental; urgency=medium

  * Rename static library libproto.a -> libcaffeproto.a and add it back
    to the -dev package. (Closes: #862528)

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 15 May 2017 02:08:06 +0000

caffe (1.0.0-1) experimental; urgency=medium

  * New upstream release. The first upstream stable release.
    The version number is imported as 1.0.0 instead of 1.0 (upstream)
    for correct dpkg version comparison.
  * Patchset update:
    - Remove merged patch make-using-gnuinstalldirs .
    - Remove merged patch fix-more-float-comparison-precision-issue .
    - Drop patch post_rc5_upstream_updates.patch .
  * Rules: update CAFFE_SOVER and get-orig-source accordingly.
  * Control:
    + Add missing dependency: python3-pydotplus .
    + Update package description: upstream lab renamed from BVLC to BAIR.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 17 Apr 2017 02:52:44 +0000

caffe (1.0.0~rc5-1) experimental; urgency=medium

  * New upstream RC release.
  * Update CAFFE_SOVER and get-orig-source target in rules.
  * Update patches:
    - Remove cmake-avoid-argument-missing, cmake-bump-soversion-to-rc4.patch .
    - Refresh the other patches.
    - Cherry-pick upstream updates to rc5: post_rc5_upstream_updates.patch .

 -- Zhou Mo <cdluminate@gmail.com>  Wed, 15 Mar 2017 08:10:16 +0000

=== debian/control ===
Source: caffe
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends-Indep: doxygen,
                     doxygen-latex
Build-Depends: bc,
               cmake,
               bash-completion,
               debhelper (>=11~),
               dh-python,
               git,
# libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-python-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libhdf5-dev,
               libleveldb-dev,
               liblmdb-dev,
# switch libblas.so.3 between Atlas and OpenBLAS with update-alternatives
               libblas-dev | libblas.so,
               libopencv-dev (>= 2.4),
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               protobuf-compiler,
# python3 depssome of them are not B-D but we need them as runtime-deps to pass the testsuite
               python3-dev,
               python3-numpy,
               cython3,
               ipython3,
               python3,
               python3-skimage,
               python3-protobuf,
               python3-dateutil,
               python3-gflags,
               python3-h5py,
               python3-leveldb,
               python3-matplotlib,
               python3-networkx,
               python3-nose,
#              python3-opencv, # this is recommended if available but it doesn't block
               python3-pandas,
               python3-pil,
               python3-pydotplus,
               python3-scipy,
               python3-six,
               python3-yaml,
Standards-Version: 4.1.3
Homepage: http://caffe.berkeleyvision.org
Vcs-Browser: https://salsa.debian.org/science-team/caffe
Vcs-Git: https://salsa.debian.org/science-team/caffe.git
X-Python-Version: >= 3.3

Package: caffe-cpu
Section: metapackages
Architecture: any
Depends: caffe-tools-cpu   (= ${binary:Version}),
         python3-caffe-cpu (= ${binary:Version}),
         libcaffe-cpu1     (= ${binary:Version}),
# the default libblas.so.3 comes from pkg:libblas3, with low performance.
         libopenblas-base | libatlas3-base | libblas.so.3 ,
         ${misc:Depends},
Suggests: libcaffe-cpu-dev (= ${binary:Version}),
          caffe-doc        (= ${binary:Version}),
Conflicts: caffe-cuda
Description: Fast, open framework for Deep Learning (Meta)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 This metapackage pulls CPU_ONLY version of caffe:
  * caffe-tools-cpu
  * libcaffe-cpu*
  * python3-caffe-cpu
 And suggests these packages:
  * libcaffe-cpu-dev
  * caffe-doc
 .
 Note, this CPU_ONLY version cannot co-exist with the CUDA version.

Package: caffe-tools-cpu
Architecture: any
Multi-Arch: foreign
Depends: libcaffe-cpu1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: caffe-tools-cuda
Description: Tools for fast, open framework for Deep Learning (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains caffe executables, configured as CPU_ONLY.

Package: libcaffe-cpu1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libcaffe-cuda1
Description: library of Caffe, deep learning framework (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains caffe shared library, configured as CPU_ONLY.

Package: libcaffe-cpu-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libcaffe-cuda-dev
Depends: libcaffe-cpu1 (= ${binary:Version}), ${misc:Depends}
Suggests: caffe-doc
Description: development files for Caffe (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains development files of caffe.

Package: python3-caffe-cpu
Section: python
Architecture: any
Multi-Arch: foreign
Depends: libcaffe-cpu1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
Conflicts: python3-caffe-cuda
Description: Python3 interface of Caffe (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains python3 interface of caffe, configured as CPU_ONLY.

Package: caffe-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         libjs-mathjax,
         libjs-jquery,
         libjs-bootstrap,
Description: Caffe's doxygen docs and examples
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 This package contains doxygen documents (both HTML version and
 PDF version) and some other documents and examples.
 .
 The HTML doc can be found here: /usr/share/doc/caffe-doc/html/index.html
 The PDF doc can be found here: /usr/share/doc/caffe-doc/refman.pdf.gz

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# Hardening Caffe according to https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DEB_CFLAGS_MAINT_APPEND   = -Wall #-pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall #-pedantic
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
RULES         := debian/rules
ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/1.0.tar.gz"
CAFFE_SOVER   := 1.0.0
BUILDDIR      := "caffe_cpu_build"

TEMPLATES     := $(wildcard debian/*.in)
AUTOGEN       := $(patsubst %.in,%,$(TEMPLATES))

## CMake Configuration Template.
## * PLEASE sync this common template with caffe-contrib source.
CMAKE_CONFIGURE_TEMPLATE = \
	-DALLOW_LMDB_NOLOCK=OFF \
	-DBLAS="Generic" \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_docs=OFF \
	-DBUILD_matlab=OFF \
	-DBUILD_python=ON \
	-DBUILD_python_layer=ON \
	-Dpython_version="3" \
	-DCMAKE_BUILD_TYPE="Release" \
	-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
	-DCMAKE_SKIP_RPATH=TRUE \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DUSE_CUDNN=OFF \
	-DUSE_LEVELDB=ON \
	-DUSE_LMDB=ON \
	-DUSE_OPENCV=ON \
	-DCPU_ONLY=$(FILL_THIS_BLANK) \
	-DCMAKE_INSTALL_PREFIX="/usr"
# These flags are for cuda version but please keep them
#	-DCUDA_ARCH_NAME="All"
#	-DCMAKE_CXX_COMPILER=g++-5
#	-DCMAKE_C_COMPILER=gcc-5

CONFFLAG_CPU = \
	$(CMAKE_CONFIGURE_TEMPLATE) \
	-DCPU_ONLY=ON

%:: %.in
	perl -p \
	-e 's{#CAFFE_CONFIGURE#}{caffe_cpu}g;' \
	-e 's{#CAFFE_SOVER#}{$(CAFFE_SOVER)}g;' \
	-e 's{#DEB_HOST_MULTIARCH#}{$(DEB_HOST_MULTIARCH)}g;' \
	< $< > $@

%:
	dh $@ \
		--parallel \
		--buildsystem=cmake \
		--with python3,bash-completion

override_dh_auto_configure: $(AUTOGEN)
	dh_auto_configure --builddirectory=$(BUILDDIR) \
		-- $(CONFFLAG_CPU)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(BUILDDIR)
	-$(RM) -rf python/caffe/proto/ doxygen
	-$(RM) python/caffe/_caffe.so
	-find . -type d -name '__pycache__' -exec rm -rf '{}' +

override_dh_auto_build-indep:
	doxygen .Doxyfile # we don't use BUILD_DOC provided by upstream cmake
	$(MAKE) -C doxygen/latex/
	find docs -name '.gitignore' -delete # lintian vcs-control-file
	find docs -name '*.html' -exec sed -i -e "s@http://cdn.mathjax.org/mathjax/latest/MathJax.js@file:///usr/share/javascript/mathjax/MathJax.js@g" '{}' \; # lintian privacy-breach-uses-embedded-file
	find examples -name '*.html' -exec sed -i -e "s@//netdna.bootstrapcdn.com/bootstrap/3.1.1/js/bootstrap.min.js@file:///usr/share/javascript/bootstrap/js/bootstrap.min.js@g" '{}' \; # lintian privacy-breach-uses-embedded-file
	find examples -name '*.html' -exec sed -i -e "s@//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css@file:///usr/share/javascript/bootstrap/css/bootstrap.min.css@g" '{}' \; # lintian privacy-breach-uses-embedded-file
	find examples -name '*.html' -exec sed -i -e "s@//code.jquery.com/jquery-2.1.1.js@file:///usr/share/javascript/jquery/jquery.js@g" '{}' \; # lintian privacy-breach-uses-embedded-file

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=$(BUILDDIR) \
		-- caffe pycaffe test.testbin all

# In the test phase, we need to set LD_LIBRARY_PATH properly
# for those test ELFs linked with libcaffe.so.X
override_dh_auto_test-arch:
	dh_auto_test --builddirectory=$(BUILDDIR) \
		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/
override_dh_auto_test-indep:

override_dh_python3:
	dh_python3 --requires=python/requirements.txt
	dh_numpy3

override_dh_install:
	dh_install
	dh_missing --list-missing

override_dh_auto_install-arch:
	dh_auto_install --builddirectory=$(BUILDDIR) -- install
override_dh_auto_install-indep:

override_dh_makeshlibs:
	dh_makeshlibs --package=python3-caffe-cpu -X/usr/lib/python
	dh_makeshlibs --remaining-packages

override_dh_fixperms-arch:
	dh_fixperms
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/caffe_pb2.py
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py

get-orig-source:
	wget -c $(ORIG_SOURCE) -O caffe_1.0.0.orig.tar.gz

=== debian/watch ===
version=3

opts="uversionmangle=s/^rc/v.1.0.0~rc/;s/v.//;s/rc./rc/,filenamemangle=s/(?:.*)?(v|rc)?(\d[\d\.]*)\.tar\.gz/caffe-$1.tar.gz/" \
  https://github.com/BVLC/caffe/tags (?:.*/)?(v|rc)?(\d[\d\.]*)\.tar\.gz

## caffe 1.0.0%2Bgit20180821.99bd997

=== debian/control ===
Source: caffe
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends-Indep: doxygen,
                     doxygen-latex
Build-Depends: bc,
               cmake,
               bash-completion,
               debhelper-compat (= 13),
               dh-python,
# libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-python-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libhdf5-dev,
               libleveldb-dev,
               liblmdb-dev,
# switch libblas.so.3 between Atlas and OpenBLAS with update-alternatives
               libblas-dev | libblas.so,
               libopencv-dev (>= 2.4) [!m68k !powerpc !sh4 !sparc64 !x32],
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               protobuf-compiler,
# python3 depssome of them are not B-D but we need them as runtime-deps to pass the testsuite
               python3-dev,
               python3-numpy,
               cython3,
               ipython3,
               python3,
               python3-distutils,
               python3-skimage,
               python3-protobuf,
               python3-dateutil,
               python3-gflags,
               python3-h5py,
               python3-matplotlib,
               python3-networkx,
               python3-nose,
#              python3-opencv, # this is recommended if available but it doesn't block
               python3-pandas,
               python3-pil,
               python3-pydotplus,
               python3-scipy,
               python3-six,
               python3-yaml,
Standards-Version: 4.5.0
Homepage: http://caffe.berkeleyvision.org
Vcs-Browser: https://salsa.debian.org/science-team/caffe
Vcs-Git: https://salsa.debian.org/science-team/caffe.git

Package: caffe
Architecture: any
Multi-Arch: foreign
Depends: libcaffe1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Conflicts: caffe-tools-cuda
Breaks: caffe-cpu, caffe-tools-cpu
Replaces: caffe-cpu, caffe-tools-cpu
Description: Tools for fast, open framework for Deep Learning (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains caffe executables, configured as CPU_ONLY.
 .
 Issue this command at the root of caffe source tree for a unit test:
   $ caffe-gtest --gtest_shuffle --gtest_filter="-*GPU*"

Package: libcaffe1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
 libopenblas-base | libatlas3-base | libmkl-rt | libblas.so.3,
Conflicts: libcaffe-cuda1
Breaks: libcaffe-cpu1
Replaces: libcaffe-cpu1
Description: library of Caffe, deep learning framework (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains caffe shared library, configured as CPU_ONLY.

Package: libcaffe-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libcaffe-cuda-dev
Depends: libcaffe1 (= ${binary:Version}), ${misc:Depends}
Suggests: caffe-doc
Breaks: libcaffe-cpu-dev
Replaces: libcaffe-cpu-dev
Description: development files for Caffe (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains development files of caffe.

Package: python3-caffe
Section: python
Architecture: any
Multi-Arch: foreign
Depends: libcaffe1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
Conflicts: python3-caffe-cuda
Breaks: python3-caffe-cpu
Replaces: python3-caffe-cpu
Description: Python3 interface of Caffe (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains python3 interface of caffe, configured as CPU_ONLY.

Package: caffe-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         libjs-mathjax,
         libjs-jquery,
         libjs-bootstrap,
Description: Caffe's doxygen docs and examples
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 This package contains doxygen documents (both HTML version and
 PDF version) and some other documents and examples.
 .
 The HTML doc can be found here: /usr/share/doc/caffe-doc/html/index.html
 The PDF doc can be found here: /usr/share/doc/caffe-doc/refman.pdf.gz

## caffe 1.0.0+git20180821.99bd997

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
if(POLICY CMP0046)
  cmake_policy(SET CMP0046 NEW)
endif()
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

# ---[ Caffe project
project(Caffe C CXX)

# ---[ Caffe version
set(CAFFE_TARGET_VERSION "1.0.0" CACHE STRING "Caffe logical version")
set(CAFFE_TARGET_SOVERSION "1.0.0" CACHE STRING "Caffe soname version")
add_definitions(-DCAFFE_VERSION=${CAFFE_TARGET_VERSION})

# ---[ Using cmake scripts and modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)

include(ExternalProject)
include(GNUInstallDirs)

include(cmake/Utils.cmake)
include(cmake/Targets.cmake)
include(cmake/Misc.cmake)
include(cmake/Summary.cmake)
include(cmake/ConfigGen.cmake)

# ---[ Options
caffe_option(CPU_ONLY  "Build Caffe without CUDA support" OFF) # TODO: rename to USE_CUDA
caffe_option(USE_CUDNN "Build Caffe with cuDNN library support" ON IF NOT CPU_ONLY)
caffe_option(USE_NCCL "Build Caffe with NCCL library support" OFF)
caffe_option(BUILD_SHARED_LIBS "Build shared libraries" ON)
caffe_option(BUILD_python "Build Python wrapper" ON)
set(python_version "2" CACHE STRING "Specify which Python version to use")
caffe_option(BUILD_matlab "Build Matlab wrapper" OFF IF UNIX OR APPLE)
caffe_option(BUILD_docs   "Build documentation" ON IF UNIX OR APPLE)
caffe_option(BUILD_python_layer "Build the Caffe Python layer" ON)
caffe_option(USE_OPENCV "Build with OpenCV support" ON)
caffe_option(USE_LEVELDB "Build with levelDB" ON)
caffe_option(USE_LMDB "Build with lmdb" ON)
caffe_option(ALLOW_LMDB_NOLOCK "Allow MDB_NOLOCK when reading LMDB files (only if necessary)" OFF)
caffe_option(USE_OPENMP "Link with OpenMP (when your BLAS wants OpenMP and you get linker errors)" OFF)

# This code is taken from https://github.com/sh1r0/caffe-android-lib
caffe_option(USE_HDF5 "Build with hdf5" ON)

# ---[ Dependencies
include(cmake/Dependencies.cmake)

# ---[ Flags
if(UNIX OR APPLE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall")
endif()

caffe_set_caffe_link()

if(USE_libstdcpp)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libstdc++")
  message("-- Warning: forcing libstdc++ (controlled by USE_libstdcpp option in cmake)")
endif()

# ---[ Warnings
caffe_warnings_disable(CMAKE_CXX_FLAGS -Wno-sign-compare -Wno-uninitialized)

# ---[ Config generation
configure_file(cmake/Templates/caffe_config.h.in "${PROJECT_BINARY_DIR}/caffe_config.h")

# ---[ Includes
set(Caffe_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/include)
set(Caffe_SRC_DIR ${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR})

# ---[ Includes & defines for CUDA

# cuda_compile() does not have per-call dependencies or include pathes
# (cuda_compile() has per-call flags, but we set them here too for clarity)
#
# list(REMOVE_ITEM ...) invocations remove PRIVATE and PUBLIC keywords from collected definitions and include pathes
if(HAVE_CUDA)
  # pass include pathes to cuda_include_directories()
  set(Caffe_ALL_INCLUDE_DIRS ${Caffe_INCLUDE_DIRS})
  list(REMOVE_ITEM Caffe_ALL_INCLUDE_DIRS PRIVATE PUBLIC)
  cuda_include_directories(${Caffe_INCLUDE_DIR} ${Caffe_SRC_DIR} ${Caffe_ALL_INCLUDE_DIRS})

  # add definitions to nvcc flags directly
  set(Caffe_ALL_DEFINITIONS ${Caffe_DEFINITIONS})
  list(REMOVE_ITEM Caffe_ALL_DEFINITIONS PRIVATE PUBLIC)
  list(APPEND CUDA_NVCC_FLAGS ${Caffe_ALL_DEFINITIONS})
endif()

# ---[ Subdirectories
add_subdirectory(src/gtest)
add_subdirectory(src/caffe)
add_subdirectory(tools)
add_subdirectory(examples)
add_subdirectory(python)
add_subdirectory(matlab)
add_subdirectory(docs)

# ---[ Linter target
add_custom_target(lint COMMAND ${CMAKE_COMMAND} -P ${PROJECT_SOURCE_DIR}/cmake/lint.cmake)

# ---[ pytest target
if(BUILD_python)
  add_custom_target(pytest COMMAND python${python_version} -m unittest discover -s caffe/test WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/python )
  add_dependencies(pytest pycaffe)
endif()

# ---[ uninstall target
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/Uninstall.cmake
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/Uninstall.cmake)

# ---[ Configuration summary
caffe_print_configuration_summary()

# ---[ Export configs generation
caffe_generate_export_configs()

=== Makefile ===
PROJECT := caffe

CONFIG_FILE := Makefile.config
# Explicitly check for the config file, otherwise make -k will proceed anyway.
ifeq ($(wildcard $(CONFIG_FILE)),)
$(error $(CONFIG_FILE) not found. See $(CONFIG_FILE).example.)
endif
include $(CONFIG_FILE)

BUILD_DIR_LINK := $(BUILD_DIR)
ifeq ($(RELEASE_BUILD_DIR),)
	RELEASE_BUILD_DIR := .$(BUILD_DIR)_release
endif
ifeq ($(DEBUG_BUILD_DIR),)
	DEBUG_BUILD_DIR := .$(BUILD_DIR)_debug
endif

DEBUG ?= 0
ifeq ($(DEBUG), 1)
	BUILD_DIR := $(DEBUG_BUILD_DIR)
	OTHER_BUILD_DIR := $(RELEASE_BUILD_DIR)
else
	BUILD_DIR := $(RELEASE_BUILD_DIR)
	OTHER_BUILD_DIR := $(DEBUG_BUILD_DIR)
endif

# All of the directories containing code.
SRC_DIRS := $(shell find * -type d -exec bash -c "find {} -maxdepth 1 \
	\( -name '*.cpp' -o -name '*.proto' \) | grep -q ." \; -print)

# The target shared library name
LIBRARY_NAME := $(PROJECT)
LIB_BUILD_DIR := $(BUILD_DIR)/lib
STATIC_NAME := $(LIB_BUILD_DIR)/lib$(LIBRARY_NAME).a
DYNAMIC_VERSION_MAJOR 		:= 1
DYNAMIC_VERSION_MINOR 		:= 0
DYNAMIC_VERSION_REVISION 	:= 0
DYNAMIC_NAME_SHORT := lib$(LIBRARY_NAME).so
#DYNAMIC_SONAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR)
DYNAMIC_VERSIONED_NAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR).$(DYNAMIC_VERSION_MINOR).$(DYNAMIC_VERSION_REVISION)
DYNAMIC_NAME := $(LIB_BUILD_DIR)/$(DYNAMIC_VERSIONED_NAME_SHORT)
COMMON_FLAGS += -DCAFFE_VERSION=$(DYNAMIC_VERSION_MAJOR).$(DYNAMIC_VERSION_MINOR).$(DYNAMIC_VERSION_REVISION)

##############################
# Get all source files
##############################
# CXX_SRCS are the source files excluding the test ones.
CXX_SRCS := $(shell find src/$(PROJECT) ! -name "test_*.cpp" -name "*.cpp")
# CU_SRCS are the cuda source files
CU_SRCS := $(shell find src/$(PROJECT) ! -name "test_*.cu" -name "*.cu")
# TEST_SRCS are the test source files
TEST_MAIN_SRC := src/$(PROJECT)/test/test_caffe_main.cpp
TEST_SRCS := $(shell find src/$(PROJECT) -name "test_*.cpp")
TEST_SRCS := $(filter-out $(TEST_MAIN_SRC), $(TEST_SRCS))
TEST_CU_SRCS := $(shell find src/$(PROJECT) -name "test_*.cu")
GTEST_SRC := src/gtest/gtest-all.cpp
# TOOL_SRCS are the source files for the tool binaries
TOOL_SRCS := $(shell find tools -name "*.cpp")
# EXAMPLE_SRCS are the source files for the example binaries
EXAMPLE_SRCS := $(shell find examples -name "*.cpp")
# BUILD_INCLUDE_DIR contains any generated header files we want to include.
BUILD_INCLUDE_DIR := $(BUILD_DIR)/src
# PROTO_SRCS are the protocol buffer definitions
PROTO_SRC_DIR := src/$(PROJECT)/proto
PROTO_SRCS := $(wildcard $(PROTO_SRC_DIR)/*.proto)
# PROTO_BUILD_DIR will contain the .cc and obj files generated from
# PROTO_SRCS; PROTO_BUILD_INCLUDE_DIR will contain the .h header files
PROTO_BUILD_DIR := $(BUILD_DIR)/$(PROTO_SRC_DIR)
PROTO_BUILD_INCLUDE_DIR := $(BUILD_INCLUDE_DIR)/$(PROJECT)/proto
# NONGEN_CXX_SRCS includes all source/header files except those generated
# automatically (e.g., by proto).
NONGEN_CXX_SRCS := $(shell find \
	src/$(PROJECT) \
	include/$(PROJECT) \
	python/$(PROJECT) \
	matlab/+$(PROJECT)/private \
	examples \
	tools \
	-name "*.cpp" -or -name "*.hpp" -or -name "*.cu" -or -name "*.cuh")
LINT_SCRIPT := scripts/cpp_lint.py
LINT_OUTPUT_DIR := $(BUILD_DIR)/.lint
LINT_EXT := lint.txt
LINT_OUTPUTS := $(addsuffix .$(LINT_EXT), $(addprefix $(LINT_OUTPUT_DIR)/, $(NONGEN_CXX_SRCS)))
EMPTY_LINT_REPORT := $(BUILD_DIR)/.$(LINT_EXT)
NONEMPTY_LINT_REPORT := $(BUILD_DIR)/$(LINT_EXT)
# PY$(PROJECT)_SRC is the python wrapper for $(PROJECT)
PY$(PROJECT)_SRC := python/$(PROJECT)/_$(PROJECT).cpp
PY$(PROJECT)_SO := python/$(PROJECT)/_$(PROJECT).so
PY$(PROJECT)_HXX := include/$(PROJECT)/layers/python_layer.hpp
# MAT$(PROJECT)_SRC is the mex entrance point of matlab package for $(PROJECT)
MAT$(PROJECT)_SRC := matlab/+$(PROJECT)/private/$(PROJECT)_.cpp
ifneq ($(MATLAB_DIR),)
	MAT_SO_EXT := $(shell $(MATLAB_DIR)/bin/mexext)
endif
MAT$(PROJECT)_SO := matlab/+$(PROJECT)/private/$(PROJECT)_.$(MAT_SO_EXT)

##############################
# Derive generated files
##############################
# The generated files for protocol buffers
PROTO_GEN_HEADER_SRCS := $(addprefix $(PROTO_BUILD_DIR)/, \
		$(notdir ${PROTO_SRCS:.proto=.pb.h}))
PROTO_GEN_HEADER := $(addprefix $(PROTO_BUILD_INCLUDE_DIR)/, \
		$(notdir ${PROTO_SRCS:.proto=.pb.h}))
PROTO_GEN_CC := $(addprefix $(BUILD_DIR)/, ${PROTO_SRCS:.proto=.pb.cc})
PY_PROTO_BUILD_DIR := python/$(PROJECT)/proto
PY_PROTO_INIT := python/$(PROJECT)/proto/__init__.py
PROTO_GEN_PY := $(foreach file,${PROTO_SRCS:.proto=_pb2.py}, \
		$(PY_PROTO_BUILD_DIR)/$(notdir $(file)))
# The objects corresponding to the source files
# These objects will be linked into the final shared library, so we
# exclude the tool, example, and test objects.
CXX_OBJS := $(addprefix $(BUILD_DIR)/, ${CXX_SRCS:.cpp=.o})
CU_OBJS := $(addprefix $(BUILD_DIR)/cuda/, ${CU_SRCS:.cu=.o})
PROTO_OBJS := ${PROTO_GEN_CC:.cc=.o}
OBJS := $(PROTO_OBJS) $(CXX_OBJS) $(CU_OBJS)
# tool, example, and test objects
TOOL_OBJS := $(addprefix $(BUILD_DIR)/, ${TOOL_SRCS:.cpp=.o})
TOOL_BUILD_DIR := $(BUILD_DIR)/tools
TEST_CXX_BUILD_DIR := $(BUILD_DIR)/src/$(PROJECT)/test
TEST_CU_BUILD_DIR := $(BUILD_DIR)/cuda/src/$(PROJECT)/test
TEST_CXX_OBJS := $(addprefix $(BUILD_DIR)/, ${TEST_SRCS:.cpp=.o})
TEST_CU_OBJS := $(addprefix $(BUILD_DIR)/cuda/, ${TEST_CU_SRCS:.cu=.o})
TEST_OBJS := $(TEST_CXX_OBJS) $(TEST_CU_OBJS)
GTEST_OBJ := $(addprefix $(BUILD_DIR)/, ${GTEST_SRC:.cpp=.o})
EXAMPLE_OBJS := $(addprefix $(BUILD_DIR)/, ${EXAMPLE_SRCS:.cpp=.o})
# Output files for automatic dependency generation
DEPS := ${CXX_OBJS:.o=.d} ${CU_OBJS:.o=.d} ${TEST_CXX_OBJS:.o=.d} \
	${TEST_CU_OBJS:.o=.d} $(BUILD_DIR)/${MAT$(PROJECT)_SO:.$(MAT_SO_EXT)=.d}
# tool, example, and test bins
TOOL_BINS := ${TOOL_OBJS:.o=.bin}
EXAMPLE_BINS := ${EXAMPLE_OBJS:.o=.bin}
# symlinks to tool bins without the ".bin" extension
TOOL_BIN_LINKS := ${TOOL_BINS:.bin=}
# Put the test binaries in build/test for convenience.
TEST_BIN_DIR := $(BUILD_DIR)/test
TEST_CU_BINS := $(addsuffix .testbin,$(addprefix $(TEST_BIN_DIR)/, \
		$(foreach obj,$(TEST_CU_OBJS),$(basename $(notdir $(obj))))))
TEST_CXX_BINS := $(addsuffix .testbin,$(addprefix $(TEST_BIN_DIR)/, \
		$(foreach obj,$(TEST_CXX_OBJS),$(basename $(notdir $(obj))))))
TEST_BINS := $(TEST_CXX_BINS) $(TEST_CU_BINS)
# TEST_ALL_BIN is the test binary that links caffe dynamically.
TEST_ALL_BIN := $(TEST_BIN_DIR)/test_all.testbin

##############################
# Derive compiler warning dump locations
##############################
WARNS_EXT := warnings.txt
CXX_WARNS := $(addprefix $(BUILD_DIR)/, ${CXX_SRCS:.cpp=.o.$(WARNS_EXT)})
CU_WARNS := $(addprefix $(BUILD_DIR)/cuda/, ${CU_SRCS:.cu=.o.$(WARNS_EXT)})
TOOL_WARNS := $(addprefix $(BUILD_DIR)/, ${TOOL_SRCS:.cpp=.o.$(WARNS_EXT)})
EXAMPLE_WARNS := $(addprefix $(BUILD_DIR)/, ${EXAMPLE_SRCS:.cpp=.o.$(WARNS_EXT)})
TEST_WARNS := $(addprefix $(BUILD_DIR)/, ${TEST_SRCS:.cpp=.o.$(WARNS_EXT)})
TEST_CU_WARNS := $(addprefix $(BUILD_DIR)/cuda/, ${TEST_CU_SRCS:.cu=.o.$(WARNS_EXT)})
ALL_CXX_WARNS := $(CXX_WARNS) $(TOOL_WARNS) $(EXAMPLE_WARNS) $(TEST_WARNS)
ALL_CU_WARNS := $(CU_WARNS) $(TEST_CU_WARNS)
ALL_WARNS := $(ALL_CXX_WARNS) $(ALL_CU_WARNS)

EMPTY_WARN_REPORT := $(BUILD_DIR)/.$(WARNS_EXT)
NONEMPTY_WARN_REPORT := $(BUILD_DIR)/$(WARNS_EXT)

##############################
# Derive include and lib directories
##############################
CUDA_INCLUDE_DIR := $(CUDA_DIR)/include

CUDA_LIB_DIR :=
# add <cuda>/lib64 only if it exists
ifneq ("$(wildcard $(CUDA_DIR)/lib64)","")
	CUDA_LIB_DIR += $(CUDA_DIR)/lib64
endif
CUDA_LIB_DIR += $(CUDA_DIR)/lib

INCLUDE_DIRS += $(BUILD_INCLUDE_DIR) ./src ./include
ifneq ($(CPU_ONLY), 1)
	INCLUDE_DIRS += $(CUDA_INCLUDE_DIR)
	LIBRARY_DIRS += $(CUDA_LIB_DIR)
	LIBRARIES := cudart cublas curand
endif

LIBRARIES += glog gflags protobuf boost_system boost_filesystem m

# handle IO dependencies
USE_LEVELDB ?= 1
USE_LMDB ?= 1
# This code is taken from https://github.com/sh1r0/caffe-android-lib
USE_HDF5 ?= 1
USE_OPENCV ?= 1

ifeq ($(USE_LEVELDB), 1)
	LIBRARIES += leveldb snappy
endif
ifeq ($(USE_LMDB), 1)
	LIBRARIES += lmdb
endif
# This code is taken from https://github.com/sh1r0/caffe-android-lib
ifeq ($(USE_HDF5), 1)
	LIBRARIES += hdf5_hl hdf5
endif
ifeq ($(USE_OPENCV), 1)
	LIBRARIES += opencv_core opencv_highgui opencv_imgproc

	ifeq ($(OPENCV_VERSION), 3)
		LIBRARIES += opencv_imgcodecs
	endif

endif
PYTHON_LIBRARIES ?= boost_python python2.7
WARNINGS := -Wall -Wno-sign-compare

##############################
# Set build directories
##############################

DISTRIBUTE_DIR ?= distribute
DISTRIBUTE_SUBDIRS := $(DISTRIBUTE_DIR)/bin $(DISTRIBUTE_DIR)/lib
DIST_ALIASES := dist
ifneq ($(strip $(DISTRIBUTE_DIR)),distribute)
		DIST_ALIASES += distribute
endif

ALL_BUILD_DIRS := $(sort $(BUILD_DIR) $(addprefix $(BUILD_DIR)/, $(SRC_DIRS)) \
	$(addprefix $(BUILD_DIR)/cuda/, $(SRC_DIRS)) \
	$(LIB_BUILD_DIR) $(TEST_BIN_DIR) $(PY_PROTO_BUILD_DIR) $(LINT_OUTPUT_DIR) \
	$(DISTRIBUTE_SUBDIRS) $(PROTO_BUILD_INCLUDE_DIR))

##############################
# Set directory for Doxygen-generated documentation
##############################
DOXYGEN_CONFIG_FILE ?= ./.Doxyfile
# should be the same as OUTPUT_DIRECTORY in the .Doxyfile
DOXYGEN_OUTPUT_DIR ?= ./doxygen
DOXYGEN_COMMAND ?= doxygen
# All the files that might have Doxygen documentation.
DOXYGEN_SOURCES := $(shell find \
	src/$(PROJECT) \
	include/$(PROJECT) \
	python/ \
	matlab/ \
	examples \
	tools \
	-name "*.cpp" -or -name "*.hpp" -or -name "*.cu" -or -name "*.cuh" -or \
        -name "*.py" -or -name "*.m")
DOXYGEN_SOURCES += $(DOXYGEN_CONFIG_FILE)


##############################
# Configure build
##############################

# Determine platform
UNAME := $(shell uname -s)
ifeq ($(UNAME), Linux)
	LINUX := 1
else ifeq ($(UNAME), Darwin)
	OSX := 1
	OSX_MAJOR_VERSION := $(shell sw_vers -productVersion | cut -f 1 -d .)
	OSX_MINOR_VERSION := $(shell sw_vers -productVersion | cut -f 2 -d .)
endif

# Linux
ifeq ($(LINUX), 1)
	CXX ?= /usr/bin/g++
	GCCVERSION := $(shell $(CXX) -dumpversion | cut -f1,2 -d.)
	# older versions of gcc are too dumb to build boost with -Wuninitalized
	ifeq ($(shell echo | awk '{exit $(GCCVERSION) < 4.6;}'), 1)
		WARNINGS += -Wno-uninitialized
	endif
	# boost::thread is reasonably called boost_thread (compare OS X)
	# We will also explicitly add stdc++ to the link target.
	LIBRARIES += boost_thread stdc++
	VERSIONFLAGS += -Wl,-soname,$(DYNAMIC_VERSIONED_NAME_SHORT) -Wl,-rpath,$(ORIGIN)/../lib
endif

# OS X:
# clang++ instead of g++
# libstdc++ for NVCC compatibility on OS X >= 10.9 with CUDA < 7.0
ifeq ($(OSX), 1)
	CXX := /usr/bin/clang++
	ifneq ($(CPU_ONLY), 1)
		CUDA_VERSION := $(shell $(CUDA_DIR)/bin/nvcc -V | grep -o 'release [0-9.]*' | tr -d '[a-z ]')
		ifeq ($(shell echo | awk '{exit $(CUDA_VERSION) < 7.0;}'), 1)
			CXXFLAGS += -stdlib=libstdc++
			LINKFLAGS += -stdlib=libstdc++
		endif
		# clang throws this warning for cuda headers
		WARNINGS += -Wno-unneeded-internal-declaration
		# 10.11 strips DYLD_* env vars so link CUDA (rpath is available on 10.5+)
		OSX_10_OR_LATER   := $(shell [ $(OSX_MAJOR_VERSION) -ge 10 ] && echo true)
		OSX_10_5_OR_LATER := $(shell [ $(OSX_MINOR_VERSION) -ge 5 ] && echo true)
		ifeq ($(OSX_10_OR_LATER),true)
			ifeq ($(OSX_10_5_OR_LATER),true)
				LDFLAGS += -Wl,-rpath,$(CUDA_LIB_DIR)
			endif
		endif
	endif
	# gtest needs to use its own tuple to not conflict with clang
	COMMON_FLAGS += -DGTEST_USE_OWN_TR1_TUPLE=1
	# boost::thread is called boost_thread-mt to mark multithreading on OS X
	LIBRARIES += boost_thread-mt
	# we need to explicitly ask for the rpath to be obeyed
	ORIGIN := @loader_path
	VERSIONFLAGS += -Wl,-install_name,@rpath/$(DYNAMIC_VERSIONED_NAME_SHORT) -Wl,-rpath,$(ORIGIN)/../../build/lib
else
	ORIGIN := \$$ORIGIN
endif

# Custom compiler
ifdef CUSTOM_CXX
	CXX := $(CUSTOM_CXX)
endif

# Static linking
ifneq (,$(findstring clang++,$(CXX)))
	STATIC_LINK_COMMAND := -Wl,-force_load $(STATIC_NAME)
else ifneq (,$(findstring g++,$(CXX)))

=== requirements.txt ===
Cython>=0.19.2
numpy>=1.7.1
scipy>=0.13.2
scikit-image>=0.9.3
matplotlib>=1.3.1
ipython>=3.0.0
h5py>=2.2.0
leveldb>=0.191
networkx>=1.8.1
nose>=1.3.0
pandas>=0.12.0
python-dateutil>=1.4,<2
protobuf>=2.5.0
python-gflags>=2.0
pyyaml>=3.10
Pillow>=2.3.0
six>=1.1.0

=== caffe/test/CMakeLists.txt ===
# The option allows to include in build only selected test files and exclude all others
# Usage example:
#  cmake -DBUILD_only_tests="common,net,blob,im2col_kernel"
set(BUILD_only_tests "" CACHE STRING "Blank or comma-separated list of test files to build without 'test_' prefix and extension")
caffe_leave_only_selected_tests(test_srcs ${BUILD_only_tests})
caffe_leave_only_selected_tests(test_cuda ${BUILD_only_tests})

# For 'make runtest' target we don't need to embed test data paths to
# source files, because test target is executed in source directory
# That's why the lines below are commented. TODO: remove them

# definition needed to include CMake generated files
#add_definitions(-DCMAKE_BUILD)

# generates test_data/sample_data_list.txt.gen.cmake
#caffe_configure_testdatafile(test_data/sample_data_list.txt)

set(the_target test.testbin)
set(test_args --gtest_shuffle)

if(HAVE_CUDA)
  caffe_cuda_compile(test_cuda_objs ${test_cuda})
  list(APPEND test_srcs ${test_cuda_objs} ${test_cuda})
else()
  list(APPEND test_args --gtest_filter="-*GPU*")
endif()

# ---[ Adding test target
add_executable(${the_target} EXCLUDE_FROM_ALL ${test_srcs})
target_link_libraries(${the_target} gtest ${Caffe_LINK})
caffe_default_properties(${the_target})
caffe_set_runtime_directory(${the_target} "${PROJECT_BINARY_DIR}/test")

# ---[ Adding runtest
add_custom_target(runtest COMMAND ${the_target} ${test_args}
                          WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

=== debian/changelog ===
caffe (1.0.0+git20180821.99bd997-5build3) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:00:29 +0000

caffe (1.0.0+git20180821.99bd997-5build2) focal; urgency=medium

  * No-change upload for opencv soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 02 Feb 2020 09:17:04 +0100

caffe (1.0.0+git20180821.99bd997-5build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 06:19:14 +0000

caffe (1.0.0+git20180821.99bd997-5) unstable; urgency=medium

  * Remove the deprecated python3-leveldb from B-D. (Closes: #947497)
  * Remove leveldb from python requirements: pyrequire-no-leveldb.patch

 -- Mo Zhou <lumin@debian.org>  Sat, 11 Jan 2020 15:48:56 +0800

caffe (1.0.0+git20180821.99bd997-4) unstable; urgency=medium

  * Remove git from B-D to unblock build on hppa,hurd-i386,ia64
  * Disable OpenCV B-D on m68k,powerpc,sh4,sparc64,x32

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 29 Oct 2019 11:27:48 +0800

caffe (1.0.0+git20180821.99bd997-3) unstable; urgency=medium

  * Cherry-pick PR#6693 to fix FTBFS against OpenCV4. (Closes: #922569)
  * Bump debhelper compat level to 12.
  * Bump Standards-Version to 4.4.0 (no change).
  * Add not-installed to silent dh-missing.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 17 Oct 2019 12:35:06 +0800

caffe (1.0.0+git20180821.99bd997-2) unstable; urgency=medium

  * Ignore precision issue on mips* machines which may lack an FPU.
    (Closes: #915108)

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 06 Dec 2018 04:24:33 +0000

caffe (1.0.0+git20180821.99bd997-1) unstable; urgency=medium

  [ Mo Zhou ]
  * New upstream version 1.0.0+git20180821.99bd997
  * libcaffe.so Depends on OpenBLAS or Atlas or MKL. (Closes: #898941)
  * Package caffe-cpu doesn't need to Depend on libopenblas-base or alike.
  * Bump Standards-Version to 4.2.0 (no change).

  [ Dimitri John Ledkov ]
  * Fix finding the right boost-python. (1.0.0-8ubuntu1) (Closes: #914067)

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 25 Nov 2018 02:36:07 +0000

caffe (1.0.0-8) unstable; urgency=medium

  * Fix FTBFS on Arch=all due to installing a file that is not built.
    (Closes: #899133)
  * Add upstream unittest to autopkgtest control file.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 20 May 2018 07:08:19 +0000

caffe (1.0.0-7) unstable; urgency=medium

  * Install upstream unittests as a part of the tools package.
  * Build-Depend on python3-distutils (See: #894203)
  * Strip unneeded --parallel option from rules, because compat=11 .
  * Bump X-Python-Version to 3.5 .
  * Bump Standards-Version to 4.1.4 (no change).
  * Update watch file to version=4 .

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 19 May 2018 13:47:43 +0000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: caffe
 Section: science
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends-Indep: doxygen,
                      doxygen-latex
 Build-Depends: bc,
                cmake,
                bash-completion,
-               debhelper-compat (= 13),
+               debhelper-compat (= 12),
                dh-python,
 # libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
                libboost-dev,
@@ -50,18 +51,41 @@
                python3-scipy,
                python3-six,
                python3-yaml,
-Standards-Version: 4.5.0
+Standards-Version: 4.4.0
 Homepage: http://caffe.berkeleyvision.org
 Vcs-Browser: https://salsa.debian.org/science-team/caffe
 Vcs-Git: https://salsa.debian.org/science-team/caffe.git
 
-Package: caffe
+Package: caffe-cpu
+Section: metapackages
+Architecture: any
+Depends: caffe-tools-cpu   (= ${binary:Version}),
+         python3-caffe-cpu (= ${binary:Version}),
+         libcaffe-cpu1     (= ${binary:Version}),
+         ${misc:Depends},
+Suggests: libcaffe-cpu-dev (= ${binary:Version}),
+          caffe-doc        (= ${binary:Version}),
+Conflicts: caffe-cuda
+Description: Fast, open framework for Deep Learning (Meta)
+ Caffe is a deep learning framework made with expression, speed,
+ and modularity in mind. It is developed by the Berkeley AI Research
+ Lab (BAIR) and community contributors.
+ .
+ This metapackage pulls CPU_ONLY version of caffe:
+  * caffe-tools-cpu
+  * libcaffe-cpu*
+  * python3-caffe-cpu
+ And suggests these packages:
+  * libcaffe-cpu-dev
+  * caffe-doc
+ .
+ Note, this CPU_ONLY version cannot co-exist with the CUDA version.
+
+Package: caffe-tools-cpu
 Architecture: any
 Multi-Arch: foreign
-Depends: libcaffe1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libcaffe-cpu1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Conflicts: caffe-tools-cuda
-Breaks: caffe-cpu, caffe-tools-cpu
-Replaces: caffe-cpu, caffe-tools-cpu
 Description: Tools for fast, open framework for Deep Learning (CPU_ONLY)
  Caffe is a deep learning framework made with expression, speed,
  and modularity in mind. It is developed by the Berkeley AI Research
@@ -72,15 +96,13 @@
  Issue this command at the root of caffe source tree for a unit test:
    $ caffe-gtest --gtest_shuffle --gtest_filter="-*GPU*"
 
-Package: libcaffe1
+Package: libcaffe-cpu1
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends},
  libopenblas-base | libatlas3-base | libmkl-rt | libblas.so.3,
 Conflicts: libcaffe-cuda1
-Breaks: libcaffe-cpu1
-Replaces: libcaffe-cpu1
 Description: library of Caffe, deep learning framework (CPU_ONLY)
  Caffe is a deep learning framework made with expression, speed,
  and modularity in mind. It is developed by the Berkeley AI Research
@@ -88,15 +110,13 @@
  .
  It contains caffe shared library, configured as CPU_ONLY.
 
-Package: libcaffe-dev
+Package: libcaffe-cpu-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Conflicts: libcaffe-cuda-dev
-Depends: libcaffe1 (= ${binary:Version}), ${misc:Depends}
+Depends: libcaffe-cpu1 (= ${binary:Version}), ${misc:Depends}
 Suggests: caffe-doc
-Breaks: libcaffe-cpu-dev
-Replaces: libcaffe-cpu-dev
 Description: development files for Caffe (CPU_ONLY)
  Caffe is a deep learning framework made with expression, speed,
  and modularity in mind. It is developed by the Berkeley AI Research
@@ -104,17 +124,15 @@
  .
  It contains development files of caffe.
 
-Package: python3-caffe
+Package: python3-caffe-cpu
 Section: python
 Architecture: any
 Multi-Arch: foreign
-Depends: libcaffe1 (= ${binary:Version}),
+Depends: libcaffe-cpu1 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
          ${python3:Depends},
 Conflicts: python3-caffe-cuda
-Breaks: python3-caffe-cpu
-Replaces: python3-caffe-cpu
 Description: Python3 interface of Caffe (CPU_ONLY)
  Caffe is a deep learning framework made with expression, speed,
  and modularity in mind. It is developed by the Berkeley AI Research

=== debian/rules ===
--- 
+++ 
@@ -10,12 +10,17 @@
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 RULES         := debian/rules
-ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/1.0.tar.gz"
 CAFFE_SOVER   := 1.0.0
 BUILDDIR      := "caffe_cpu_build"
 
 TEMPLATES     := $(wildcard debian/*.in)
 AUTOGEN       := $(patsubst %.in,%,$(TEMPLATES))
+
+# arch-dependent cmake flags
+ARCHS_NO_OPENCV := m68k sparc64 sh4 x32 powerpc
+ifneq (,$(findstring $(DEB_HOST_ARCH),$(ARCHS_NO_OPENCV)))
+ADCF = -DUSE_OPENCV=OFF
+endif
 
 ## CMake Configuration Template.
 ## * PLEASE sync this common template with caffe-contrib source.
@@ -38,15 +43,16 @@
 	-DUSE_LMDB=ON \
 	-DUSE_OPENCV=ON \
 	-DCPU_ONLY=$(FILL_THIS_BLANK) \
-	-DCMAKE_INSTALL_PREFIX="/usr"
-# These flags are for cuda version but please keep them
+	-DCMAKE_INSTALL_PREFIX="/usr" 
+
+# These flags are for the cuda version but please keep them
 #	-DCUDA_ARCH_NAME="All"
 #	-DCMAKE_CXX_COMPILER=g++-5
 #	-DCMAKE_C_COMPILER=gcc-5
 
 CONFFLAG_CPU = \
 	$(CMAKE_CONFIGURE_TEMPLATE) \
-	-DCPU_ONLY=ON
+	-DCPU_ONLY=ON $(ADCF)
 
 %:: %.in
 	perl -p \
@@ -56,10 +62,7 @@
 	< $< > $@
 
 %:
-	dh $@ \
-		--parallel \
-		--buildsystem=cmake \
-		--with python3,bash-completion
+	dh $@ -Scmake --with python3,bash-completion
 
 override_dh_auto_configure: $(AUTOGEN)
 	dh_auto_configure --builddirectory=$(BUILDDIR) \
@@ -87,8 +90,14 @@
 # In the test phase, we need to set LD_LIBRARY_PATH properly
 # for those test ELFs linked with libcaffe.so.X
 override_dh_auto_test-arch:
+ifeq (,$(filter mips, $(DEB_HOST_ARCH)))
 	dh_auto_test --builddirectory=$(BUILDDIR) \
 		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/
+else
+	# Ignore precision problems in mips*
+	-dh_auto_test --builddirectory=$(BUILDDIR) \
+		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/
+endif
 override_dh_auto_test-indep:
 
 override_dh_python3:
@@ -97,6 +106,10 @@
 
 override_dh_install:
 	dh_install
+	# The upstream unittest can be used to verify the BLAS correctness.
+	# the two lines start with dash in order to avoid FTBFS on Arch=all.
+	-mv caffe_cpu_build/test/test.testbin  caffe-gtest
+	-install -m0755 caffe-gtest debian/caffe-tools-cpu/usr/bin/
 	dh_missing --list-missing
 
 override_dh_auto_install-arch:
@@ -111,6 +124,3 @@
 	dh_fixperms
 	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/caffe_pb2.py
 	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py
-
-get-orig-source:
-	wget -c $(ORIG_SOURCE) -O caffe_1.0.0.orig.tar.gz

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%caffe-$1.tar.gz%" \
    https://github.com/bvlc/caffe/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
